-------------------------------------------------
--             Zurak's A.I. Script     
--                 version 1.0           
--------------------------------------------------
-- v1.0 || 12/22/12 || Supports Bomb/Defuse Maps (de_).
--------------------------------------------------
--                      Settings              
--------------------------------------------------
gravity_space = 3 -- space were members will go when leader is moving.
gravity_far = 4 -- space where members will go when leader is walking or standing still.
c4radius = 15 --c4 radius where bots will not go when they run away from exploding bomb.
c4timer = 35  --c4 radius
strafe_style = {-5,8,22} --3 types of strafing styles for bots, the bigger the number the more forward motion.
weaponmode = 1 -- 0 = botcon mode, 1=normal weapons/gear, 2= fun weapons/gear(equip).
squad = 2 -- pick either players in groups of 2 or 1, 1 player groups is less buggy but less advanced.
buy_flash = true -- change to false to disable.
buy_he = true -- change to false to disable.
buy_smoke = true  -- change to false to disable.
knife_range = 30 -- the range when a player tries to knife another player(in pixels)
pick_up = true -- pick up weapons?
strafetime = 10 --how fast should a bot strafe the bigger the slower.
swarm = 3 --how many deaths until bot gives up on target building.
--------------------------------------------------
--------------------------------------------------

squad_list = {}
ai_objective = {} ai_destination = {} 
player_deaths = {} player_destroying = {} player_building = {} player_equiped = {} player_squad = {} player_rank = {} player_target = {} player_walking = {} player_incombat = {} player_inrange = {} player_planting = {} player_flashed = {} player_style = {}
player_spraying = {} player_sprayspot = {} player_logotimer = {}
movecheck_x = {} movecheck_y = {} player_walk = {} timer3 = {}
rank_name_edit = {} rank_color_edit = {}
player_loot = {}
draw_timer = {}
zai_timer2 = {}
strafe_dir = {} strafe_speed = {} zai_timer =  {} spawn = {{},{}}
vis = {}
h4x_ = {}
carrier = {}
buy_choice = {}
z = 0
vip = 0
bomb_defusing = false
radio_busy = true
bombtimer = 0
gamemode=tonumber(game("sv_gamemode"))
botskill=tonumber(game("bot_skill"))
botweapons=tonumber(game("bot_weapons"))

	function reset_status(id)
		player_deaths[id] = 0
		player_style[id] = math.random(1,3)
		player_walking[id] = 3
		player_walk[id] = 3
		zai_timer[id] = 0
		strafe_speed[id] = 0
		draw_timer[id] = 0
		strafe_dir[id] = 1
		player_incombat[id] = false
		player_inrange[id] = false
		player_planting[id] = false
		player_spraying[id] = false
		player_inrange[id] = false
		player_flashed[id] = false
		player_loot[id][1] = nil
		player_loot[id][2] = nil
		carrier[id] = false
		ai_destination[id][1] = 0
		ai_destination[id][2] = 0
	end
	
	for i = 1,32 do
		player_equiped[i] = {}
		player_sprayspot[i] = {}
		ai_destination[i] = {}
		ai_destination[i][1] = 0
		ai_destination[i][2] = 0
		player_sprayspot[i][1] = 0
		player_sprayspot[i][2] = 0
		squad_list[i] = {}
		timer3[i] = 0
		ai_objective[i] = {}
		player_loot[i] = {}
		reset_status(i)
		player_destroying[i] = false
	end
	
	addhook("startround_prespawn","zai_prespawn")
	function zai_prespawn()
		for i = 1,32 do
			reset_status(i)
			squad_list[i][1] = nil
			squad_list[i][2] = nil
			player_squad[i] = nil
			player_rank[i] = nil
		end
		spawn[2][1],spawn[2][2] = randomentity(1)
		spawn[1][1],spawn[1][2] = randomentity(0)
		bombtimer = 0
		gamemode=tonumber(game("sv_gamemode"))
		botskill=tonumber(game("bot_skill"))
		botweapons=tonumber(game("bot_weapons"))
	end
	
	if weaponmode == 1 then --normal
		buy_primary = {{},{},{10,11},{20,22,23,24,39,30,38,32},{30,31,32,33,38,39},{34,36,37},{40}}
		buy_secondary = {1,2,3,4,5,6}
		buy_gear = {58,59,61,62,56}
		if buy_he == true then buy_gear[#buy_gear+1] = 51 end
		if buy_flash == true then buy_gear[#buy_gear+1] = 52 end
		if buy_smoke == true then buy_gear[#buy_gear+1] = 53 end
	elseif weaponmode == 2 then -- fun
		equip_gun = {45,46,91,90,49,48,47,30,32}
		equip_gear = {79,80,81,82,84,83}
	end
	
	function round2(num,idp)
		return tonumber(string.format("%." .. (idp or 0) .. "f", num))
	end
	
	function item_stat(id)
		if id ~= nil then
			return (itemtype(id,"dmg")/2+itemtype(id,"range")/2+itemtype(id,"rate")-itemtype(id,"reload")-itemtype(id,"dispersion"))/5 
		end
	end

	function zai_buy(id,mode)
		if weaponmode == 0 then
			if player_style[id] == 1 then
				parse('equip '..id..' 22')
			elseif player_style[id] == 2 then
				parse('equip '..id..' 24')
				parse('equip '..id..' 53')
				parse('equip '..id..' 52')
				parse('equip '..id..' 52')
			elseif player_style[id] == 3 then
				parse('equip '..id..' 5')
				parse('equip '..id..' 58')
				parse('equip '..id..' 51')
			end
		elseif weaponmode == 1 then
			keep = math.random(1,3)
			for i = 1,#buy_primary do
				if botweapons == i or botweapons == 0 then
					for ii = 1,#buy_primary[i] do
						if #buy_primary[i] > 0 then
							buy_choice[(#buy_choice)+1] = buy_primary[i][ii]
						end
					end
				end
			end
			if botweapons ~= 2 and botweapons ~= 1 then
				for i = 1,12 do 
					local pick = math.random(1,#buy_choice)
					if pick == 59 and player_style[id] ==1 then
						pick = math.random(1,#buy_choice)
					end
					if item(pick,"player") ~= id and buy_choice[pick] ~= nil and player(id,"money") >= itemtype(buy_choice[pick],"price")	then 
						if player_equiped[id][1] == nil or (keep == 2 and item_stat(buy_choice[pick]) > item_stat(player_equiped[id][1])) then
						--	msg(''..buy_choice[pick]..'')
							ai_buy(id,buy_choice[pick])
							player_equiped[id][1] = buy_choice[pick]
							buy_choice = {}
							break
						end
					end
				end
			end
			if botweapons == 2 or botweapons == 0 and keep == 2 then
				for i = 1,2 do
					local pick = math.random(1,6)
					if item(pick,"player") ~= id and player(id,"money") >= itemtype(buy_secondary[pick],"price") and (player_equiped[id][2] == nil or item_stat(buy_secondary[pick]) > item_stat(player_equiped[id][2])) then
						ai_buy(id,buy_secondary[pick])
						player_equiped[id][2] = buy_secondary[pick]
						break
					end
				end
			end
			for i = 1,5 do
				local pick = math.random(1,#buy_gear)
				if item(pick,"player") ~= id and player(id,"money") >= itemtype(buy_gear[pick],"price") then
					ai_buy(id,58)
					ai_buy(id,buy_gear[pick])
				end
			end
		elseif weaponmode == 2 then
			local pick = math.random(1,#equip_gear)
			parse('equip '..id..' '..equip_gear[pick]..'')
			local pick = math.random(1,#equip_gun)
			parse('equip '..id..' '..equip_gun[pick]..'')
		end
	end

	function set_squad(id)
		if player_squad[id]==nil then
			for i = 1,32 do
				if  #squad_list[i] == 0 then
					local pos = #squad_list[i]+1
					squad_list[i][pos] = id
					player_squad[id] = i
					player_rank[id] = pos
					break
				elseif #squad_list[i] < squad  and player(id,"team") == player(squad_list[i][1],"team") then
					local pos = #squad_list[i]+1
					squad_list[i][pos] = id
					player_squad[id] = i
					player_rank[id] = pos
					break
				end
			end
		end
	--	msg('name: '..player(id,"name")..' | rank: '..player_rank[id]..' | squad: '..player_squad[id]..' | team: '..player(id,"team")..'')
	end

	addhook("die","zai_ondeath")
	function zai_ondeath(id,killer,weapon,x_pix,y_pix)
		player_deaths[id] = player_deaths[id] + 1
		if player_deaths[id] >= swarm then
			player_deaths[id] = 0
		end
		reset_status(id)
		player_equiped[id][1] = nil
		player_equiped[id][2] = nil
	end
	
	addhook("leave","zai_onleave")
	function zai_onleave(id)
		reset_status(id)
		player_equiped[id][1] = nil
		player_equiped[id][2] = nil
	end
	
	addhook("spawn","zai_onspawn")
	function zai_onspawn(id)
		if player(id,"bot") == true and map("nobuying") == 0 then
			zai_buy(id)
		end
		if player_rank[id] == nil or squad_list[player_squad[id]][1] == nil then
			set_squad(id)
		end
	end
	
	addhook("drop","zai_drop")
	function zai_drop(id,iid,itype,ain,a,mode,x,y)
		if itype == 55 then
			vis[1] = x	
			vis[2] = y
			bomb_id = iid
		end
	end
	
	function check_bomb(id)
		a = dist_calc(player(id,"tilex"),player(id,"tiley"),vis[1],vis[2])
		if b == nil or a < b then	
			closest_to_bomb = id
		end
		b = a
	end
	
	addhook("collect","zai_collect")
	function zai_collect(id,iid,itype)
		if itype == 55 and player(id,"team") == 1 then
			bomb_id = nil
			vis[1] = nil
			vis[2] = nil
		elseif itype > 6 and itype < 50 then
			player_equiped[id][1] = itype
		elseif itype < 7 then
			player_equiped[id][2] = itype
		end
	end

	function set_destination(id,target,distance)
		c=0
		if target == "objective" then
			ai_destination[id][1] = ai_objective[id][1]
			ai_destination[id][2] = ai_objective[id][2]
		elseif target == "random" then
			while  c< 20 do
				ai_destination[id][1] = math.random(0,map("xsize"))
				ai_destination[id][2] = math.random(0,map("ysize"))
				if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1  then
					break
				end
				c=c+1
			end
		elseif target == "bombspot" then
			local ex,ey=randomentity(5)
			while  c< 20 do 
				ai_destination[id][1] = math.random(ex-distance,ex+distance)
				ai_destination[id][2] = math.random(ey-distance,ey+distance)
				if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1 then
					break
				end
				c=c+1
			end
		elseif target == "target" then
			if timer3[id] == 0 then
				while c< 20 do 
					ai_destination[id][1] = player(player_target[id],"tilex")
					ai_destination[id][2] = player(player_target[id],"tiley")
					if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1 then
						break
					end
					c=c+1
				end
			end
		elseif target == "randombuilding" then
			for _,oid in pairs(object(0,"table")) do
				local n = math.random(1,#object(0,"table"))
				if n == 1 and object(oid,"team") == 3-player(id,"team") and ai_freeline(id,object(oid,"x"),object(oid,"y")) then
					player_building[id] = oid
					local tx = object(oid,"tilex")
					local ty = object(oid,"tiley")
					while  c< 20 do
						if tx ~= nil and ty ~= nil then
							ai_destination[id][1]= math.random(tx-distance,tx+distance)
							ai_destination[id][2]= math.random(ty-distance,ty+distance)
						--	msg('2  '..ai_destination[id][1]..','..ai_destination[id][2]..'')
						else
							return false
						end
						if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1  then
						--	msg('1   '..ai_destination[id][1]..','..ai_destination[id][2]..'')
							player_destroying[id] = true
							return true
						end
						c=c+1
					end
					msg('3  '..ai_destination[id][1]..','..ai_destination[id][2]..'')
				end
			end
			return false
		elseif target == "mate" then
			while  c< 20 do 
				if distance == 0 then
					ai_destination[id][1] = player(squad_list[player_squad[id]][3-player_rank[id]],"tilex")
					ai_destination[id][2] = player(squad_list[player_squad[id]][3-player_rank[id]],"tiley")
				else
					ai_destination[id][1]= math.random(player(squad_list[player_squad[id]][3-player_rank[id]],"tilex")-distance,player(squad_list[player_squad[id]][3-player_rank[id]],"tilex")+distance)
					ai_destination[id][2]= math.random(player(squad_list[player_squad[id]][3-player_rank[id]],"tiley")-distance,player(squad_list[player_squad[id]][3-player_rank[id]],"tiley")+distance)
				end
				if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1  then
					break
				end
				c=c+1
			end
		elseif target == "help_mate" then
			local leader = squad_list[player_squad[id]][1]
			local tx = ai_destination[leader][1]
			local ty = ai_destination[leader][2]
			while  c< 20 do 
				if tx ~= nil and ty ~= nil then
					ai_destination[id][1]= math.random(tx-distance,tx+distance)
					ai_destination[id][2]= math.random(ty-distance,ty+distance)
				else
					break
				end
				if tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1  then
					break
				end
				c=c+1
			end
		elseif target == "cover_vis" then
			while  c< 20 do 
				if distance == 0 then
					ai_destination[id][1] = vis[1]
					ai_destination[id][2] = vis[2]
				else
					ai_destination[id][1]= math.random(vis[1]-distance,vis[1]+distance)
					ai_destination[id][2]= math.random(vis[2]-distance,vis[2]+distance)
				end
				if tile(ai_destination[id][1],ai_destination[id][2],"frame") == nil or (tile(ai_destination[id][1],ai_destination[id][2],"walkable") and tile(ai_destination[id][1],ai_destination[id][2],"frame") > 1)  then
					break
				end
				c=c+1
			end
		end
	end
	
	function ai_onspawn(id)
		player_equiped[id][2] = 3 - player(id,"team")
		zai_buy(id)
	end
	
	function dist_calc(x_a,y_a,x_b,y_b)
		return math.sqrt(math.abs((y_b-y_a)*(y_b-y_a)) + math.abs((x_b-x_a)*(x_b-x_a)))
	end
	
	function update_combat(id)
		local target = ai_findtarget(id)
		if player_flashed[id] == false and target > 0 and player(target,"exists") and player(target,"health") > 0 and math.abs(player(target,"x")-player(id,"x")) < 333 and math.abs(player(target,"y")-player(id,"y")) < 254 then
			player_inrange[id] = true
			player_target[id] = target
			if botweapons ~= 1 and ai_freeline(id,player(target,"x"),player(target,"y")) then
				if player_equiped[id][1] == 10 or player_equiped[id][1] == 11 then
					if dist_calc(player(player_target[id],"tilex"),player(player_target[id],"tiley"),player(id,"tilex"),player(id,"tiley")) < 2 then
						player_incombat[id] = true
						player_destroying[id] = false
						player_sprayspot[id][1] = player(target,"x")
						player_sprayspot[id][2] = player(target,"y")
					else
						player_incombat[id] = false
					end
				else
					player_incombat[id] = true
					player_sprayspot[id][1] = player(target,"x")
					player_sprayspot[id][2] = player(target,"y")
				end
			else
				timer(500,"parse",'lua "check_combat('..(id)..')')
			end
		else
			player_incombat[id] = false
			player_inrange[id] = false
			player_target[id] = nil
		end
	end
	
	function check_combat(id)
		if player_target[id] ~= nil and (player(player_target[id],"exists") == false or player(player_target[id],"health") <= 0 or ai_freeline(id,player(player_target[id],"x"),player(player_target[id],"y")) == false) then
			player_incombat[id] = false
		end
	end
	
	function zai_attack(id,x,y)
		if dist_calc(x,y,player(id,"x"),player(id,"y")) < knife_range then
			ai_selectweapon(id,"50")
			ai_attack(id)
		elseif math.abs(player(id,"rot") - angleto(player(id,"x"),player(id,"y"),x,y)) < player_style[id]*18 then
			if timer3[id] == 0 then
				if player_incombat[id] == true and player_style[id] >1 then
					if buy_flash then
						ai_selectweapon(id,"52")
					elseif buy_he then
						ai_selectweapon(id,"51")
					end
				end
			end
			if player(id,"weapontype") == 52 and buy_flash then
				ai_attack(id)
			elseif player(id,"weapontype") == 51 and buy_he then
				ai_attack(id)
			else
				ai_iattack(id)
			end
		end
	end
	
	function update_squad(id)
		if player_rank[id] > 1 then
			if player(squad_list[player_squad[id]][1],"exists") == false or player(squad_list[player_squad[id]][1],"health") == 0 then
				squad_list[player_squad[id]][1] = id
				squad_list[player_squad[id]][2] = nil
				player_rank[id] = 1
			--	msg('name: '..player(id,"name")..' | rank: '..player_rank[id]..' | squad: '..player_squad[id]..' | team: '..player(id,"team")..'')
			end
		elseif player_rank[id] == 1 and squad_list[player_squad[id]][2] ~= nil then
			if player(squad_list[player_squad[id]][2],"exists") == false or player(squad_list[player_squad[id]][2],"health") == 0 then
				squad_list[player_squad[id]][2] = nil
			elseif squad_list[player_squad[id]][2] ~= nil and player(squad_list[player_squad[id]][2],"bot") == false then
				squad_list[player_squad[id]][1] = squad_list[player_squad[id]][2]
				squad_list[player_squad[id]][2] = id
				player_rank[id] = 2
				player_rank[squad_list[player_squad[id]][1]] = 1
			--	msg('name: '..player(id,"name")..' | rank: '..player_rank[id]..' | squad: '..player_squad[id]..' | team: '..player(id,"team")..'')
			end
		end
	end
	
	function update_position(id)
		if ai_destination[id][1] == 0 or ai_destination[id][1] == nil then
			ai_destination[id][1] = player(id,"tilex")
			ai_destination[id][2] = player(id,"tiley")
			ai_objective[id][1] = player(id,"tilex")
			ai_objective[id][2] = player(id,"tiley")
		end
		if player_flashed[id] == false and player_incombat[id] == false then
			if player_walk[id] == 2 then
				status = ai_goto(id,ai_destination[id][1],ai_destination[id][2],1)
			else
				status = ai_goto(id,ai_destination[id][1],ai_destination[id][2])
			end
		end
	end

	function plant(id)
		if player(id,"weapontype")~=55 then
			ai_selectweapon(id,55)
		else
			ai_attack(id)
		end
	end
	
	addhook("hit","zai_sprayback")
	function zai_sprayback(id,a_id,weapon,h_dmg,a_dmg,r_dmg)
		if player_spraying[id] == false then
			for _,oid in pairs(object(0,"table")) do
				if object(oid,"team") == 3-player(id,"team") and (object(oid,"type") == 8 or object(oid,"type") == 7) and math.abs(object(oid,"x")-player(id,"x"))<325 and math.abs(object(oid,"y")-player(id,"y")) < 250 then
					player_spraying[id] = true
					player_sprayspot[id][1] = object(oid,"x")
					player_sprayspot[id][2] = object(oid,"y")
					timer(2000,"parse",'lua "update_spray('..(id)..','..player(id,"health")..','..(0)..','..(oid)..')')
					break
				end
			end
		elseif player(a_id,"exists") then
			if player_flashed[id] == false and player(a_id,"health") > 0 and player_spraying[id] == false and player(a_id,"team") ~= player(id,"team") then
				player_spraying[id] = true
				player_sprayspot[id][1] = player(a_id,"x")
				player_sprayspot[id][2] = player(a_id,"y")
				timer(600,"parse",'lua "update_spray('..(id)..','..player(id,"health")..','..a_id..')')
			end
		end
	end
	
	function update_spray(id,health,a_id,o_id)
		if a_id == 0 then
			player_spraying[id] = false
		elseif player(a_id,"exists") and player(a_id,"health") > 0 then 
			if player(id,"health") < health and player_incombat[id] == false then
				player_sprayspot[id][1] = player(a_id,"x")
				player_sprayspot[id][2] = player(a_id,"y")
			else
				player_spraying[id] = false
			end
		else
			player_spraying[id] = false
		end
	end
	
	addhook("projectile","zai_flash")
	function zai_flash(id,weapon,x,y)
		if weapon == 52 then
			for _,i in pairs(player(0,"tableliving")) do
				if math.abs(x-player(i,"x")) < 333 and math.abs(y-player(i,"y")) < 254 and ai_freeline(i,x,y) then
					player_flashed[i] = true
					timer(3000,"parse",'lua "update_flash('..(i)..')')
				end
			end
		end
	end
	
	function update_flash(i)
		player_flashed[i] = false
		stop(i)
	end
	
	function strafe(id,x,y,angle)
		local target_angle = angleto(player(id,"x"),player(id,"y"),x,y)
		if strafe_dir[id] <0 then
			strafe_angle = target_angle+angle+strafe_style[player_style[id]]
		elseif strafe_dir[id] >0 then
			strafe_angle = target_angle-angle-strafe_style[player_style[id]]
		end
		ai_move(id,strafe_angle)
	--	msg('ID: '..id..' speed: '..strafe_speed[id]..' dir: '..strafe_dir[id]..' zai_timer: '..zai_timer[id]..'')
	end
	
	function set_objective(id)
		ai_objective[id][1] = ai_destination[id][1]
		ai_objective[id][2] = ai_destination[id][2]
	end
	
	function stop(id)
		if player(id,"exists") and  player(id,"health") > 0 then
			ai_destination[id][1] = player(id,"tilex")
			ai_destination[id][2] = player(id,"tiley")
		end
	end
	
	function update_destination(id)
		c = 0
		if squad_list[player_squad[id]][3-player_rank[id]] ~= nil then
			local dest_to_member =	dist_calc(ai_destination[id][1],ai_destination[id][2],player(squad_list[player_squad[id]][3-player_rank[id]],"tilex"),player(squad_list[player_squad[id]][3-player_rank[id]],"tiley"))
		end
		if player(id,"team") == 1 then
		--	msg(''..(player(id,"name"))..' status: '..status..' rank: '..player_rank[id]..' | '..ai_destination[id][1]..' '..ai_destination[id][2]..'')
		end
		if player(id,"reloading") == false and player_flashed[id] == false and player_incombat[id] == true and player(player_target[id],"exists") and player(player_target[id],"health")>0 then
			local tx = player_sprayspot[id][1]
			local ty = player_sprayspot[id][2]
			local x = math.random(player_sprayspot[id][1]-25*(4-botskill),player_sprayspot[id][1]+25*(4-botskill))
			local y = math.random(player_sprayspot[id][2]-25*(4-botskill),player_sprayspot[id][2]+25*(4-botskill))
			while c < 20 do
				local x = math.random(player_sprayspot[id][1]-25*(4-botskill),player_sprayspot[id][1]+25*(4-botskill))
				local y = math.random(player_sprayspot[id][2]-25*(4-botskill),player_sprayspot[id][2]+25*(4-botskill))
				if (math.abs(tx-x) + math.abs(ty-y)) < 16 then
					break
				end
				c = c+1
			end
			ai_aim(id,x,y)
			zai_attack(id,player_sprayspot[id][1],player_sprayspot[id][2])
			strafe(id,player(player_target[id],"x"),player(player_target[id],"y"),90)
		elseif player_target[id] ~= nil and dist_calc(player(player_target[id],"x"),player(player_target[id],"y"),player(id,"x"),player(id,"y")) < knife_range then
			ai_aim(id,player(player_target[id],"x"),player(player_target[id],"y"))			
			zai_attack(id,player(player_target[id],"x"),player(player_target[id],"y"))
		else
			if botweapons ~= 1 and player_equiped[id][1] ~= 10 and player_equiped[id][1] ~= 11 and player_spraying[id] == true and player_flashed[id] == false then
				local x = math.random(player_sprayspot[id][1]-30*(4-botskill),player_sprayspot[id][1]+30*(4-botskill))
				local y = math.random(player_sprayspot[id][2]-30*(4-botskill),player_sprayspot[id][2]+30*(4-botskill))
				ai_aim(id,x,y)
				zai_attack(id,player_sprayspot[id][1],player_sprayspot[id][2])
			elseif player_building[id] ~= nil and player_incombat[id] == false and player_destroying[id] == true and object(player_building[id],"exists") and math.abs(object(player_building[id],"x")-player(id,"x"))<325 and math.abs(object(player_building[id],"y")-player(id,"y")) < 250 and ai_freeline(id,object(player_building[id],"x"),object(player_building[id],"y")) then
				local x = math.random(object(player_building[id],"x")-30*(4-botskill),object(player_building[id],"x")+30*(4-botskill))
				local y = math.random(object(player_building[id],"y")-30*(4-botskill),object(player_building[id],"y")+30*(4-botskill))
				ai_aim(id,x,y)
				zai_attack(id,object(player_building[id],"x"),object(player_building[id],"y"))
			end
			if player(id,"reloading") then
				if ai_destination[id][1] ~= spawn[player(id,"team")][1] and ai_destination[id][2] ~= spawn[player(id,"team")][2] then
					ai_destination[id][1] = spawn[player(id,"team")][1]
					ai_destination[id][2] = spawn[player(id,"team")][2]
				end
			elseif player_flashed[id] == true then
				if timer3[id] == 1 or timer3[id] == 2 then
					player_sprayspot[id][1] = math.random(player_sprayspot[id][1]-30*(6-botskill),player_sprayspot[id][1]+30*(6-botskill))
					player_sprayspot[id][2] = math.random(player_sprayspot[id][2]-30*(6-botskill),player_sprayspot[id][2]+30*(6-botskill))
				end
				ai_aim(id,player_sprayspot[id][1],player_sprayspot[id][2])
				strafe(id,player_sprayspot[id][1],player_sprayspot[id][2],-160)
				if player_style[id] < 3 then
					ai_attack(id)
				end
			elseif player_loot[id][2] ~= nil and player_loot[id][1] ~= nil and pick_up == true then
				ai_destination[id][1] = player_loot[id][1]
				ai_destination[id][2] = player_loot[id][2]
			elseif status == 1 and inentityzone(player(id,"tilex"),player(id,"tiley"),5) and player(id,"team") == 1 and player(id,"bomb") then
				plant(id)	
				ai_spray(id)
			elseif player_rank[id] == 1 then
				player_walk[id] = 3
				if player_inrange[id] and player_target[id] ~= nil and status == 1 and player_walking[id] == 0 then
					set_destination(id,"target")
				elseif squad_list[player_squad[id]][3-player_rank[id]] ~= nil and dist_calc(player(id,"tilex"),player(id,"tiley"),player(squad_list[player_squad[id]][3-player_rank[id]],"tilex"),player(squad_list[player_squad[id]][3-player_rank[id]],"tiley")) > gravity_far+2 and dest_to_member ~= nil and dest_to_member > gravity_far then
					set_destination(id,"mate",0)
				elseif bomb_id ~= nil and player(id,"team") == 1 and closest_to_bomb == id and player(id,"tilex") ~= vis[1] and player(id,"tiley") ~= vis[2] then
					set_destination(id,"cover_vis",0)          
				elseif bomb_id ~= nil and status < 2 then
					set_destination(id,"cover_vis",15)               
					set_objective(id)
				elseif game("bombplanted") == true then
					if c4timer-bombtimer < 6 then
						while dist_calc(ai_destination[id][1],ai_destination[id][2],vis[1],vis[2]) < c4radius do
							set_destination(id,"random")
						end
					elseif bomb_defusing == false and player(id,"team") == 1 and status < 2 then
						set_destination(id,"cover_vis",15)
						set_objective(id)
					elseif bomb_defusing == true and player(id,"team") == 1 then
						set_destination(id,"cover_vis",0)
						set_objective(id)
					elseif player(id,"team") == 2 then
						if player(id,"tilex") == vis[1] and player(id,"tiley") == vis[2] then
							stop(id)
							ai_use(id)
							ai_spray(id)
							bomb_defusing = true
						elseif bomb_defusing == false then
							set_destination(id,"cover_vis",0)
							set_objective(id)
						elseif bomb_defusing == true then
							if status < 2 or (ai_destination[id][1] == vis[1] and ai_destination[id][2] == vis[2]) then
								set_destination(id,"cover_vis",10)
								set_objective(id)
							end
						end
					end	
				elseif player(id,"bomb") and carrier[id] == false then
					set_destination(id,"bombspot",2)
					carrier[id] = true
					set_objective(id)
				elseif status < 2 then
					if gamemode > 0 or map("mission_bombspots") == 0 then
						if player_deaths[id] == 0 then
							if set_destination(id,"randombuilding",6) == false then
								player_destroying[id] = false
								set_destination(id,"random")
								set_objective(id)
							end
						else
							set_destination(id,"random")
							set_objective(id)
						end
					elseif carrier[id] == false then
						set_destination(id,"bombspot",15)
						set_objective(id)
					else
						set_destination(id,"objective")
					end
				elseif timer3[id] == 0 and squad_list[player_squad[id]][3-player_rank[id]] ~= nil and dist_calc(player(id,"tilex"),player(id,"tiley"),player(squad_list[player_squad[id]][3-player_rank[id]],"tilex"),player(squad_list[player_squad[id]][3-player_rank[id]],"tiley")) < gravity_far+2 then
					set_destination(id,"objective")
				end
			elseif player_rank[id] == 2 and player(squad_list[player_squad[id]][1],"exists") == true then
				local distance = dist_calc(ai_destination[id][1],ai_destination[id][2],player(squad_list[player_squad[id]][1],"tilex"),player(squad_list[player_squad[id]][1],"tiley"))
				local distance_to_destination = dist_calc(player(id,"tilex"),player(id,"tiley"),ai_destination[id][1],ai_destination[id][2])
				local distance_to_leader = dist_calc(player(id,"tilex"),player(id,"tiley"),player(squad_list[player_squad[id]][1],"tilex"),player(squad_list[player_squad[id]][1],"tiley"))
				local leader = squad_list[player_squad[id]][1]
				if player_walking[squad_list[player_squad[id]][1]] < 3 and player_inrange[leader] == false and distance_to_leader < gravity_space then
					player_walk[id] = 2
				else
					player_walk[id] = 3
				end  
				if player(id,"bomb") == true then
					ai_selectweapon (id,"55")
					ai_drop(id)
					vis[1] = player(id,"tilex")
					vis[2] = player(id,"tiley")
				elseif player_spraying[leader] or  player_incombat[leader] then
					if status < 2 and timer3[id] == 0 then
						set_destination(id,"help_mate",5)
					end
					ai_selectweapon(id,"53")
					if player(id,"weapontype") == 53 then
						ai_aim(id,player(leader,"x"),player(leader,"y"))
						ai_attack(id)
					end
					if ai_freeline(id,player_sprayspot[leader][1],player_sprayspot[leader][2]) then
						local x = math.random(player_sprayspot[leader][1]-30*(6-botskill),player_sprayspot[leader][1]+30*(6-botskill))
						local y = math.random(player_sprayspot[leader][2]-30*(6-botskill),player_sprayspot[leader][2]+30*(6-botskill))
						ai_aim(id,x,y)
						zai_attack(id,x,y)
					end
				elseif status < 2 then
					set_destination(id,"mate",gravity_space)
				elseif status == 2 then
					if distance_to_leader > gravity_far then
						if distance > gravity_space then
							set_destination(id,"mate",0)
						end
					end
				else
					msg(''..id..' error: x: '..ai_destination[id][1]..' '..ai_destination[id][2]..'')
				end
			end
		end
	end
	
	function angleto(x1,y1,x2,y2)
		return round2(math.deg(math.atan2(x2-x1,y1-y2)))
	end
	
	function ai_update_living(id)
		update_squad(id)
		update_combat(id)
		update_position(id)
		update_dropped(id)
		update_destination(id)
		player_loot[id][1] = nil
		player_loot[id][2] = nil
		if player_flashed[id] == false and player(id,"reloading") == false and player_spraying[id] == false and player_incombat[id] == false and player(id,"process") ~= 1 and player(id,"process") ~= 2 then
			draw_timer[id] = draw_timer[id] + 1
		else
			draw_timer[id] = 0
		end
			draw(id,50)
		if player_flashed[id] == false and player_spraying[id] == false and player_incombat[id] == false then
			timer(600,"parse",'lua "fai_walkaim('..(id)..','..player(id,"x")..','..player(id,"y")..')"')
		end
	end

	function draw(id,weapon)
		if player_destroying[id] == false and draw_timer[id] >= 50 and player_flashed[id] == false and player(id,"reloading") == false and player_spraying[id] == false and player_incombat[id] == false and player(id,"process") ~= 1 and player(id,"process") ~= 2 then
			if player(id,"exists") and inentityzone(player(id,"tilex"),player(id,"tiley"),5) and player(id,"team") == 1 and player(id,"bomb") then
				return
			else
				ai_selectweapon(id,weapon)
			end
		end
	end
	
	function fai_walkaim(id,px,py)
		if player_destroying[id] == false and player(id,"exists") and player_flashed[id] == false and player_incombat[id] == false and player_spraying[id] == false then
			local x=player(id,"x")
			local y=player(id,"y")
			local angle=math.deg(math.atan2(x-px,py-y))
			ai_aim(id,x+math.sin(math.rad(angle))*150,y-math.cos(math.rad(angle))*150)
		end
	end
	
	function ai_update_dead(id)
		if gamemode > 0 then
			ai_respawn(id)
		end
	end

	function ai_hear_radio(source,radio)
	end

	function check_pos(id,x,y)
		if player(id,"exists") and player(id,"health") > 0 then
			if dist_calc(x,y,player(id,"x"), player(id,"y"))<1 then
				player_walking[id] = 1
			elseif dist_calc(x,y,player(id,"x"), player(id,"y"))< 5 then
				player_walking[id] = 1.5
			elseif dist_calc(x,y,player(id,"x"), player(id,"y"))<45 then
				player_walking[id] = 2
			else
				player_walking[id] = 3
			end
		end
	end
	
	function update_dropped(id)
		if --[[botskill < 4 and player_style[id] > 1]] player_incombat[id] == false and player_spraying[id] == false and player_flashed[id] == false then
			for _,iid in pairs(closeitems(1,8)) do
				if dist_calc(player(id,"tilex"),player(id,"tiley"),item(iid,"x"),item(iid,"y")) > 2 and item(iid,"type")>6 and item(iid,"type")<50 then
					if player_equiped[id][1] == nil or item_stat(item(iid,"type")) > item_stat(player_equiped[id][1]) then
						if timer3[id] == 0 then
							player_loot[id][1] = item(iid,"x")
							player_loot[id][2] = item(iid,"y")
						end
						if player_equiped[id][1] ~= nil and dist_calc(player(id,"tilex"),player(id,"tiley"),item(iid,"x"),item(iid,"y")) <= 3 then
							ai_selectweapon(id,''..player_equiped[id][1]..'')
							ai_drop(id)
						end
						break
					end
				end
			end
		end
	end
	
--	function zai_goto(id,tilex,tiley)
--		n = 1
--		while tile(player(id,"tilex") + n,player(id,"tiley"),"walkable") do
--			n = n+1
--		end
--		while tile(player(id,"tiley") + n,player(id,"tilex"),"walkable") do
	--		n = n+1
--		end
--		angleto(tilex,tiley)
--		ai_move(id,tilex,tiley)
--	end
	
	addhook("ms100","zai_ms")
	function zai_ms()
		for _,id in pairs(player(0,"tableliving")) do
			if player(id,"bot") == true then
				if zai_timer[id] >= strafe_speed[id] then
					strafe_dir[id] = -strafe_dir[id]
					strafe_speed[id] = math.random(1,strafetime)
					zai_timer[id] = 0
				else	
					zai_timer[id] = zai_timer[id]+1
				end
			end
			timer(500,"parse",'lua "check_pos('..(id)..','..player(id,"x")..','..player(id,"y")..')"')
		end 
	end
	
	addhook("second","zai_second")
	function zai_second()
		if gamemode == 0 then
			if game("bombplanted") == true then
				bombtimer = bombtimer + 1
			end
			for i =1,#player(0,"table") do
				timer3[i] = timer3[i] + 1
				if timer3[i] >= 2 then
					timer3[i] = 0
				end
				if player(i,"process") == 2 then
					bomb_defusing = true
					break
				elseif player(i,"process") == 1 then
					bomb_planting = true
					vis[1] = player(i,"tilex")
					vis[2] = player(i,"tiley")
					break
				elseif i == #player(0,"table") then
					bomb_defusing = false
					bomb_planting = false
				end
			end
		end
		if bomb_id ~= nil then
			for _,id in pairs(player(0,"team1living")) do
				if player(id,"team") == 1 and player_rank[id] == 1 and player(id,"bot") == true then
					check_bomb(id)
				end
			end
		end
	end
	
	function ai_hear_chat(source,msg,teamonly)
		if string.find(msg, "h4x") then
			h4x = true
		end
	end
	